/// <reference path="../../headers/common.d.ts" />
System.register(["app/plugins/sdk", "app/core/app_events", "moment", "jquery"], function (exports_1, context_1) {
    "use strict";
    var __extends = (this && this.__extends) || (function () {
        var extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var __moduleName = context_1 && context_1.id;
    var sdk_1, app_events_1, moment_1, jquery_1, PanelCtrl;
    return {
        setters: [
            function (sdk_1_1) {
                sdk_1 = sdk_1_1;
            },
            function (app_events_1_1) {
                app_events_1 = app_events_1_1;
            },
            function (moment_1_1) {
                moment_1 = moment_1_1;
            },
            function (jquery_1_1) {
                jquery_1 = jquery_1_1;
            }
        ],
        execute: function () {/// <reference path="../../headers/common.d.ts" />
            PanelCtrl = /** @class */ (function (_super) {
                __extends(PanelCtrl, _super);
                function PanelCtrl($scope, $injector, $http) {
                    var _this = _super.call(this, $scope, $injector) || this;
                    _this.$scope = $scope;
                    _this.$injector = $injector;
                    _this.$http = $http;
                    // Re-init all scope params
                    _this.reset($scope);
                    $scope.logLocation = '';
                    $scope.version = '';
                    $scope.fullVersion = '';
                    $scope.versionCashed = '';
                    $scope.nextVersion = '';
                    $scope.nextFullVersion = '';
                    $scope.nextVersionCashed = '';
                    $scope.errorMessage = '';
                    $scope.canBeReloaded = false;
                    $scope.isUpdateAvailable = false;
                    $scope.isDefaultView = true;
                    $scope.newsLink = '';
                    $scope.lastCheck = '';
                    $scope.keydownCode = '';
                    $scope.checkForUpdate = _this.checkForUpdate.bind(_this, $scope, $http);
                    $scope.update = _this.update.bind(_this, $scope, $http);
                    $scope.displayFullCurrentVersion = _this.displayFullCurrentVersion.bind(_this, $scope);
                    $scope.displayFullAvailableVersion = _this.displayFullAvailableVersion.bind(_this, $scope);
                    $scope.getLog = _this.getLog.bind(_this, $scope, $http);
                    $scope.getCurrentVersion = _this.getCurrentVersion.bind(_this, $scope, $http);
                    $scope.getCurrentVersion($scope, $http);
                    var body = document.querySelector('body');
                    var escKeyCode = 'Escape';
                    body.addEventListener('click', function (event) {
                        if (jquery_1.default(event.target).hasClass('modal-backdrop') && $scope.canBeReloaded)
                            location.reload();
                    });
                    body.addEventListener('keydown', function (event) {
                        $scope.keydownCode = event.code;
                        (event.key === escKeyCode && $scope.canBeReloaded) ? location.reload() : event.stopPropagation();
                    });
                    return _this;
                }
                /**
                 * Send request for update version
                 */
                PanelCtrl.prototype.update = function ($scope, $http) {
                    var modalScope = $scope.$new(true);
                    $scope.$watch(function (newState) {
                        modalScope.output = newState.output;
                        modalScope.isChecked = newState.isChecked;
                        modalScope.isUpdated = newState.isUpdated;
                        modalScope.isUpdateAvailable = newState.isUpdateAvailable;
                        modalScope.isDefaultView = newState.isDefaultView;
                        modalScope.errorMessage = newState.errorMessage;
                        modalScope.version = newState.version;
                        modalScope.currentReleaseDate = newState.currentReleaseDate;
                        modalScope.newReleaseDate = newState.newReleaseDate;
                        modalScope.canBeReloaded = newState.canBeReloaded;
                    });
                    modalScope.reloadAfterUpdate = function () {
                        location.reload();
                    };
                    app_events_1.default.emit('show-modal', {
                        src: PanelCtrl.TEMPLATES.MODAL,
                        scope: modalScope,
                        backdrop: 'static',
                        keyboard: false
                    });
                    $http({
                        method: 'POST',
                        url: PanelCtrl.API.UPDATE,
                    }).then(function (response) {
                        $scope.logLocation = response.headers('Location');
                        $scope.getLog($scope, $http);
                    });
                };
                /**
                 * Show error message if update is fail
                 * @param message - kind of error message
                 */
                PanelCtrl.prototype.displayError = function ($scope, message) {
                    $scope.isChecked = true;
                    $scope.errorMessage = message;
                    setTimeout(function () {
                        $scope.isChecked = false;
                        $scope.errorMessage = '';
                        $scope.$apply();
                    }, 5000);
                };
                /**
                 * Send request to get current version
                 */
                PanelCtrl.prototype.getCurrentVersion = function ($scope, $http) {
                    var _this = this;
                    $http({
                        method: 'POST',
                        url: PanelCtrl.API.GET_CURRENT_VERSION,
                        data: { force: false }
                    }).then(function (res) {
                        var data = res.data;
                        $scope.lastCheckDate = data.last_check ? moment_1.default(data.last_check).locale('en').format('MMMM DD, H:mm') : '';
                        $scope.version = data.installed.version || '';
                        $scope.fullVersion = data.installed.full_version || '';
                        $scope.currentReleaseDate = data.installed.timestamp ? moment_1.default.utc(data.installed.timestamp).locale('en').format('MMMM DD') : '';
                        $scope.isUpdateAvailable = data.update_available || false;
                        if ($scope.isUpdateAvailable) {
                            _this.checkForUpdate.call(_this, $scope, $http);
                        }
                        else {
                            jquery_1.default('#refresh').removeClass('fa-spin');
                        }
                        $scope.isDefaultView = false;
                    }).catch(function () {
                        jquery_1.default('#refresh').removeClass('fa-spin');
                        //TODO: add error handler
                    });
                };
                /**
                 * Send request to check if update possible and re-init params
                 */
                PanelCtrl.prototype.checkForUpdate = function ($scope, $http) {
                    var _this = this;
                    var refreshButton = jquery_1.default('#refresh');
                    refreshButton.addClass('fa-spin');
                    $http({
                        method: 'POST',
                        url: PanelCtrl.API.CHECK_FOR_UPDATE,
                        data: { force: true }
                    }).then(function (res) {
                        var data = res.data;
                        $scope.nextVersion = data.latest.version || '';
                        $scope.nextFullVersion = data.latest.full_version || '';
                        $scope.lastCheckDate = data.last_check ? moment_1.default(data.last_check).locale('en').format('MMMM DD, H:mm') : '';
                        $scope.newReleaseDate = data.latest.timestamp ? moment_1.default.utc(data.latest.timestamp).locale('en').format('MMMM DD') : '';
                        $scope.newsLink = data.latest_news_url || '';
                        $scope.isUpdateAvailable = data.update_available || false;
                        $scope.isDefaultView = false;
                        refreshButton.removeClass('fa-spin');
                    }).catch(function () {
                        _this.displayError($scope, PanelCtrl.ERRORS.NOTHING_TO_UPDATE);
                        refreshButton.removeClass('fa-spin');
                    });
                };
                /**
                 * Send request for get info about update status
                 */
                PanelCtrl.prototype.getLog = function ($scope, $http) {
                    var _this = this;
                    if (!$scope.logLocation.length)
                        return;
                    $http({
                        method: 'GET',
                        url: $scope.logLocation,
                    }).then(function (response) {
                        $scope.output = response.data.detail;
                        if (response.data.title === PanelCtrl.PROCESS_STATUSES.IN_PROGRESS)
                            window.setTimeout(_this.getLog.bind(_this, $scope, $http), 1000);
                        if (response.data.title === PanelCtrl.PROCESS_STATUSES.DONE) {
                            _this.reset($scope);
                            $scope.version = $scope.errorMessage ? $scope.version : $scope.nextVersion;
                            $scope.currentReleaseDate = $scope.errorMessage ? $scope.currentReleaseDate : $scope.newReleaseDate;
                            $scope.isUpdated = true;
                            $scope.canBeReloaded = true;
                        }
                        if (response.data.title === PanelCtrl.PROCESS_STATUSES.FAILED) {
                            $scope.isChecked = true;
                            $scope.isUpdateAvailable = true;
                            $scope.canBeReloaded = true;
                            $scope.errorMessage = PanelCtrl.ERRORS.UPDATE;
                        }
                    }).catch(function () {
                        _this.reset($scope);
                    });
                };
                PanelCtrl.prototype.displayFullCurrentVersion = function ($scope) {
                    if ($scope.keydownCode === 'AltLeft') {
                        if ($scope.version !== $scope.fullVersion) {
                            $scope.versionCashed = $scope.version;
                            $scope.version = $scope.fullVersion;
                        }
                        else {
                            $scope.version = $scope.versionCashed;
                        }
                        $scope.keydownCode = '';
                    }
                };
                PanelCtrl.prototype.displayFullAvailableVersion = function ($scope) {
                    if ($scope.keydownCode === 'AltLeft') {
                        if ($scope.nextVersion !== $scope.nextFullVersion) {
                            $scope.nextVersionCashed = $scope.nextVersion;
                            $scope.nextVersion = $scope.nextFullVersion;
                        }
                        else {
                            $scope.nextVersion = $scope.nextVersionCashed;
                        }
                        $scope.keydownCode = '';
                    }
                };
                /**
                 * Re-init all inner parameters that can be changed during update
                 */
                PanelCtrl.prototype.reset = function ($scope) {
                    $scope.output = '';
                    $scope.isChecked = false;
                    $scope.isUpdated = false;
                    $scope.isUpdateAvailable = false;
                };
                /**
                 * Urls to define panels templates
                 */
                PanelCtrl.TEMPLATES = {
                    MAIN: 'pmm-update-panel/index.html',
                    MODAL: 'public/plugins/pmm-update-panel/modal.html',
                };
                /**
                 * Urls to define API endpoints
                 */
                PanelCtrl.API = {
                    GET_CURRENT_VERSION: '/v1/Updates/Check',
                    CHECK_FOR_UPDATE: '/v1/Updates/Check',
                    UPDATE: '/configurator/v1/updates'
                };
                /**
                 * Possible statuses of update version process (returned by backend)
                 */
                PanelCtrl.PROCESS_STATUSES = {
                    FAILED: 'failed',
                    IN_PROGRESS: 'running',
                    DONE: 'succeeded',
                    ERROR: 'error'
                };
                /**
                 * Possible errors during update process
                 */
                PanelCtrl.ERRORS = {
                    UPDATE: 'Error during update',
                    NOTHING_TO_UPDATE: 'Nothing to update',
                    INCORRECT_SERVER_RESPONSE: 'Incorrect server response'
                };
                /**
                 * Grafana param, define url of template that will be used for panel
                 */
                PanelCtrl.templateUrl = PanelCtrl.TEMPLATES.MAIN;
                return PanelCtrl;
            }(sdk_1.MetricsPanelCtrl));
            exports_1("PanelCtrl", PanelCtrl);
        }
    };
});
//# sourceMappingURL=module.js.map